/*
 * Created on 2005/03/28
 */
package net.asukaze.anxious;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;

/**
 * Anxious̊{@\܂B
 * @author asukaze
 */
public class Manager {
	private static Random rnd = new Random();
	private boolean studying = false;
	Problem[] unsolvedData = null;
	int unsolvedPos = 0;
	ArrayList historyData = null;
	int historyPos = 0;
	boolean isInHistory = false;
	ArrayList retryData = null;
	String fileName = null;
	boolean useFixedOrder;
	boolean useReversal = false;
	int timelimit;
	ArrayList goodCounter = null;
	int goodCount = 0;
	int badCount = 0;
	
	/**
	 * VManagerNX쐬܂B
	 *
	 */
	public Manager(){
		studying = false;
		unsolvedData = null;
		useReversal = false;
	}
	
	/**
	 * wKł邩ǂԂ܂B
	 * t@CJĂAS␳nextProblem()Ăяo܂ł
	 * trueԂ܂B
	 * @return wKȂtrueAłȂfalseB
	 */
	public boolean isStudying(){
		return studying;
	}
	
	String removePath(String filepath){
		int pos = filepath.lastIndexOf(File.separatorChar);
		return filepath.substring(pos+1);
	}
	
	void setReversal(boolean value){
		useReversal = value;
	}

	/**
	 * t@CJ܂B
	 * @param filename t@C
	 * @throws FileNotFoundException t@CJȂɓ܂B
	 */
	public void OpenFile(String filename) throws FileNotFoundException{
		Reader reader = new Reader();
		reader.setReversal(useReversal);
		this.unsolvedData = reader.read(filename);
		this.useFixedOrder = reader.getUseFixedOrder();
		this.timelimit = reader.getTimeLimit();
		if(!useFixedOrder){ Shuffle(unsolvedData); }
		this.unsolvedPos = 0;
		this.historyData = new ArrayList();
		this.isInHistory = false;
		this.retryData = new ArrayList();
		this.fileName = removePath(filename);
		this.goodCounter = new ArrayList();
		this.goodCount = 0;
		badCount = 0;
		studying = true;
	}

	/**
	 * ̖󂯎܂B
	 * @return ̖BSInullB
	 */
	public Problem nextProblem(){
		if(isInHistory){
			return goNext();
		}else{
			isInHistory = false;
		}
		if(unsolvedData == null || unsolvedData.length <= unsolvedPos){
			int termgoodcount = unsolvedData.length - retryData.size();
			goodCounter.add(new Integer(termgoodcount));

			if(retryData == null || retryData.size() == 0){
				studying = false;
				return null;
			}else{
				unsolvedData = new Problem[retryData.size()];
				Iterator it = retryData.iterator();
				for(int i=0; i<retryData.size(); i++){
					unsolvedData[i] = (Problem)it.next();
				}
				retryData.clear();
				if(!useFixedOrder){ Shuffle(unsolvedData); }
				unsolvedPos = 0;
			}
		}
		Problem p = unsolvedData[unsolvedPos];
		unsolvedPos++;
		return p;
	}

	/**
	 * 萳ɌĂяoĂB
	 * @param problem 
	 * @param failed ꔭȂtrueAԈȂfalse
	 */
	public void solved(Problem problem, boolean failed){
		if(!isInHistory){
			historyData.add(problem);
			if(failed){
				retryData.add(problem);
				badCount++;
			}else{
				goodCount++;
			}
		}
	}
	
	/**
	 * c̖萔B
	 * FormɖnĂȂԂŌĂяoĂB
	 * isolvedsAnextProblemsOj
	 * @return c̖萔
	 */
	public int getRemainingCount(){
		int ret = 0;
		if(unsolvedData != null){
			ret += unsolvedData.length - unsolvedPos;
		}
		if(retryData != null){
			ret += retryData.size();
		}
		return ret;
	}

	/**
	 * 1߂܂B
	 * @param prob ݉Ă
	 * @return 1O̖B߂ȂnullB
	 */
	public Problem goBack(Problem prob){
		if(!isInHistory){
			if(unsolvedPos > 0 && unsolvedData[unsolvedPos-1] == prob){
				unsolvedPos--;
			}
			historyPos = historyData.size();
		}
		isInHistory = true;
		historyPos--;
		if(historyPos >= 0){
			return (Problem)(historyData.get(historyPos));
		}
		return null;
	}
	
	/**
	 * 1i݂܂B
	 * @return ̖Bi߂ȂnullB
	 */
	public Problem goNext(){
		if(!isInHistory){ return null; }
		historyPos++;
		if(historyPos >= historyData.size()){
			isInHistory = false;
			return nextProblem();
		}
		return (Problem)(historyData.get(historyPos));
	}
	
	/**
	 * 1߂邩ǂԂ܂B
	 * @return ߂trueB
	 */
	public boolean canGoBack(){
		if(!studying){
			return false;
		}else if(isInHistory){
			return (historyPos > 0);
		}else{
			return (historyData.size() > 0);
		}
	}
	
	/**
	 * 1i߂邩ǂԂ܂B
	 * @return i߂trueB
	 */
	public boolean canGoNext(){
		return (studying && isInHistory);
	}
	
	/**
	 * pX܂܂ȂÃ݂t@CԂ܂B
	 * @return t@C
	 */
	public String getFileName(){
		return fileName;
	}

	/**
	 * ̐ڂ\AInteger̃XgԂ܂B
	 * @return e^[Ƃ̐i[ArrayList
	 */
	public ArrayList getGoodCounter(){
		return goodCounter;
	}

	/**
	 * ݂܂ł̐Ԃ܂B
	 * @return 
	 */
	public int getPercentage(){
		if(goodCount <= 0 && badCount <= 0){
			return 0;
		}
		return (goodCount * 100) / (goodCount + badCount);
	}
	
	/**
	 * z̗̓vf_ɕёւ܂B
	 * ͔̑jIłB
	 * @param arr
	 * ёւsz
	 * @return
	 * arrԂ܂B
	 */
	public static Object[] Shuffle(Object[] arr){
		for(int i=arr.length-1; i>=0; i--) {
			int j = rnd.nextInt(i+1);
			Object temp = arr[i];
			arr[i] = arr[j];
			arr[j] = temp;
		}
		return arr;
	}
	
	/**
	 * str1str2̓ꕔ̒Ԃ܂B
	 * @param str1 r镶
	 * @param str2 r镶
	 * @return v镔̒
	 */
	public static int hitLength(String str1, String str2){
		int i;
		for(i=0; i<str1.length() && i<str2.length(); i++){
			if(str1.charAt(i) != str2.charAt(i)){
				return i;
			}
		}
		return i;
	}
	
	/**
	 * o[W擾܂B
	 * @return o[W
	 */
	public static String getVersion(){
		return "2.0";
	}

	/**
	 * [XԂ܂B
	 * @return yyyy/MM/dd `̃[X
	 */
	public static String getReleaseDate(){
		return "2005/03/31";
	}
}

