/*
 * Created on 2005/03/28
 */
package net.asukaze.anxious;

import java.util.*;

/**
 * @author asukaze
 */
public class Problem {
	/* Members */
	private String question = null;
	private Collection correctAnswers = null;
	private Collection choices = null;
	private String hint = null;
	
	/* Properties */
	public String getQuestion(){
		return question;
	}
	public void setQuestion(String value){
		question = value;
	}
	public Collection getCorrectAnswers(){
		return correctAnswers;
	}
	public void setCorrectAnswers(Collection value){
		correctAnswers = value;
	}
	public Collection getChoices(){
		return choices;
	}
	public void setChoices(Collection value){
		choices = value;
	}
	public String getHint(){
		return hint;
	}
	public void setHint(String value){
		hint = value;
	}
	
	/* Methods */
	public void addChoice(String value){
		if(choices == null){
			choices = new ArrayList();
		}
		choices.add(value);
	}
	
	public boolean isValid(){
		return ((question != null) && (correctAnswers != null)
				&& !(question.equals("")) && !correctAnswers.isEmpty());		
	}
	
	public String getCorrectAnswerFor(String answer){
		int hitpos = 0;
		String ret = null;
		Iterator it = correctAnswers.iterator();
		while(it.hasNext()){
			String str = it.next().toString();
			if(str.equals(answer)){ return str; }
			while(answer.length() >= hitpos && str.startsWith(answer.substring(0, hitpos))){
				hitpos++;
				ret = str;
			}
		}
		return ret;
	}
	
	public String[] getAnswerAndChoices(){
		Collection col = new ArrayList();
		col.addAll(choices);
		col.add(correctAnswers.iterator().next());
		return (String[])Manager.Shuffle(col.toArray());
	}
}
