/*
 * Created on 2005/03/28
 */
package net.asukaze.anxious;

import java.io.*;
import java.util.ArrayList;

/**
 * t@Cǂݍ݂܂
 * @author asukaze
 */
public class Reader {
	private class Format {
		String[][] data;
		boolean useEscape;
		boolean useMultiAnswer;
		
		public void setData(String data){
			String[] lines = data.split("/");
			this.data = new String[lines.length][];
			for(int i=0; i<lines.length; i++){
				this.data[i] = lines[i].split(",");
			}
		}		

		public Format(String data){
			setData(data);
			useEscape = false;
			useMultiAnswer = false;
		}
	}

	Format format;
	boolean useFixedOrder;
	int timelimit;
	boolean useReversal;
	
	public Reader(){}
	
	public boolean getUseFixedOrder(){
		return useFixedOrder;
	}

	public int getTimeLimit(){
		return timelimit;
	}
	
	public void setReversal(boolean value){
		useReversal = value;
	}
	
	public Problem[] read(String filename) throws FileNotFoundException{
		if(filename.substring(filename.length() - 4).equalsIgnoreCase(".txt")){
			format = new Format("Q/A");
		}else{
			format = new Format("Q,A");
		}
		return read(new BufferedReader(new FileReader(filename)));
	}
	public Problem[] read(BufferedReader br){
		if(format == null){ format = new Format("Q,A"); }
		useFixedOrder = false;
		timelimit = 0;
		
		int formatpos = 0;
		ArrayList ls = new ArrayList();
		String line;
		Problem prob = new Problem();
		try{
			while((line = br.readLine()) != null){
				if(line.equals("")){
					formatpos = 0;
					if(prob.isValid()){ ls.add(prob); }
					prob = new Problem();
				}else if(line.startsWith("///") || line.startsWith("\"///")){
					readCommand(line);
				}else if(line.startsWith("//") || line.startsWith("\"//")){
					continue;
				}else{
					String[] cells;
					int formatlen = format.data[formatpos].length; 
					if(formatlen > 1){
						cells = splitCSV(line);
					}else{
						cells = new String[1];
						cells[0] = line;
					}
					for(int i=0; i<cells.length; i++){
						char qash;
						if(i < formatlen){
							qash = format.data[formatpos][i].charAt(0);
						}else if(format.data[formatpos][formatlen-1].charAt(0) == 'S'){
							qash = 'S';
						}else{
							continue;
						}
						if(useReversal){
							if(qash == 'Q'){
								qash = 'A';
							}else if(qash == 'A'){
								qash = 'Q';
							}
						}
						if(qash == 'Q'){
							prob.setQuestion(getQAList(cells[i], "\r\n", "\t").get(0).toString());
						}else if(qash == 'A'){
							prob.setCorrectAnswers(getQAList(cells[i], "", ""));
						}else if(qash == 'S'){
							prob.addChoice(cells[i]);
						}else if(qash == 'H'){
							prob.setHint(cells[i]);
						}
					} 
					formatpos++;
					if(formatpos >= format.data.length){
						formatpos = 0;
						if(prob.isValid()){ ls.add(prob); }
						prob = new Problem();
					}
				}
			}
		}catch(IOException e){}
		
		Problem[] ret = new Problem[ls.size()];
		ls.toArray(ret);
		return ret;
	}
	
	String[] splitCSV(String line){
		ArrayList ls = new ArrayList();
		StringBuffer sb = new StringBuffer();
		int pos = 0;
		boolean quoted = false;
		while(pos < line.length()){
			if(line.charAt(pos) == '\"'){
				if(quoted && (pos < line.length() - 1)
						&& (line.charAt(pos+1) == '\"')){
					sb.append('\"');
				}
				quoted = !quoted;
				pos++;
			}else if(!quoted && (line.charAt(pos) == ',' || line.charAt(pos) == '\t')){
				ls.add(sb.toString());
				sb = new StringBuffer();
				pos++;
			}else if(format.useEscape && line.charAt(pos) == '\\'){
				sb.append(line.charAt(pos));
				pos++;
				if(pos < line.length()){
					sb.append(line.charAt(pos));
					pos++;
				}
			}else{
				sb.append(line.charAt(pos));
				pos++;
			}
		}
		if(sb.length() > 0){
			ls.add(sb.toString());
		}
		String[] ret = new String[ls.size()];
		ls.toArray(ret);
		return ret;
	}
	
	void readCommand(String line){
		if(line.startsWith("\"")){ line = line.substring(1); }
		if(line.startsWith("///")){	line = line.substring(3); }
		if(line.startsWith(" ")){ line = line.substring(1); }
		String[] com = line.split(" ");
		if(com.length > 2 && com[0].equals("data")){
			if(com[1].startsWith("ver")){
				if(com[1].equals("ver.0")){
					format.setData("A/Q");
					format.useEscape = false;
					format.useMultiAnswer = false;
				}else if(com[1].equals("ver.1")){
				    format.setData("Q/A");
					format.useEscape = false;
					format.useMultiAnswer = false;
				}else if(com[1].equals("ver.1.1")){
				    format.setData("Q,A");
					format.useEscape = true;
					format.useMultiAnswer = false;
				}else if(com[1].equals("ver.1.2")){
				    format.setData("Q,A");
					format.useEscape = true;
					format.useMultiAnswer = true;
				}
			}else{
				format.setData(com[1]);
			}
		}else if(com.length > 2 && com[0].equals("use")){
			format.useEscape = (com[1].indexOf('\\') >= 0);
			format.useMultiAnswer = (com[1].indexOf('|') >= 0);
		}else if(com.length > 2 && com[0].equals("order")){
			if(com[1].equals("fixed")){ useFixedOrder = true; }
			else if(com[1].equals("random")){ useFixedOrder = false; }
		}else if(com.length > 2 && com[0].equals("timelimit")){
			timelimit = Integer.parseInt(com[1]);
		}
	}
	
	private static final char LT = 0x10;
	private static final char PIPE = 0x11;
	private static final char GT = 0x12;
	
	String unescape(String value, String strnewline, String strtab){
		StringBuffer sb = new StringBuffer();
		for(int i=0; i<value.length(); i++){
			if(value.charAt(i) == '{' && format.useMultiAnswer){
				sb.append(LT);
			}else if(value.charAt(i) == '|' && format.useMultiAnswer){
				sb.append(PIPE);
			}else if(value.charAt(i) == '}' && format.useMultiAnswer){
				sb.append(GT);
			}else if(value.charAt(i) == '\\' && format.useEscape){
				if(i >= value.length() - 1){
					sb.append('\\');
					break;
				}
				switch(value.charAt(i+1)){
					case '_': sb.append(' '); break;
					case 'n': sb.append(strnewline); break;
					case 't': sb.append(strtab); break;
					case 'q': sb.append('\"'); break;
					case 'c': sb.append(','); break;
					default:  sb.append(value.charAt(i+1)); break;
				}
				i++;
			}else if(value.charAt(i) == '\r'){
				// nop
			}else if(value.charAt(i) == '\n'){
				sb.append(strnewline);
			}else if(value.charAt(i) == '\t'){
				sb.append(strtab);
			}else{
				sb.append(value.charAt(i));
			}
		}
		return sb.toString();
	}
	
	ArrayList expand(String value){
		String left = null;
		ArrayList center = new ArrayList();
		ArrayList right = null;
		int brackets = 0;
		int ltpos = 0;
		for(int i=0; i<value.length(); i++){
			if(value.charAt(i) == LT && format.useMultiAnswer){
				if(brackets == 0){
					left = value.substring(0, i);
					ltpos = i;
				}
				brackets++;
			}else if(value.charAt(i) == PIPE && brackets == 1){
				center.addAll(expand(value.substring(ltpos+1, i)));
				ltpos = i;
			}else if(value.charAt(i) == GT && format.useMultiAnswer){
				brackets--;
				if(brackets == 0){
					center.addAll(expand(value.substring(ltpos+1, i)));
					right = expand(value.substring(i+1));
					break;
				}
			}
		}
		ArrayList ret = new ArrayList();
		if(right != null && left != null){
			for(int i=0; i<center.size(); i++){
				for(int j=0; j<right.size(); j++){
					ret.add(left + center.get(i) + right.get(j));
				}
			}
		}else{
			ret.add(value);
		}
		return ret;
	}

	ArrayList getQAList(String value, String strnewline, String strtab){
		return expand(unescape(value, strnewline, strtab));
	}
}
